	device zxspectrum128
        ORG #6000
begin
dirs:
; 0
;3 1
; 2
;
dx: db 00,1,0,-1
dy: db -1,0,1,00
runi:

; jr $
; ld c,l
; ld a,(hl)
; ld (de),a
; inc de
; inc l
; ld l,c
; inc h

;600A       4D                    LD            C ,L
;600B       7E                    LD            A ,(HL)
;600C       12                    LD            (DE)  ,A
;600D       13                    INC           DE
;600E       2C                    INC           L
;600F       69                    LD            L ,C
;6010       24                    INC           H


 ld a,#10,bc,$7FFD:out (c),a

;prepare XOR pattern
 ld hl,#C000
xor_lp:
 ld a,h:and l
 sra a
 and 7
 ld (hl),a:inc l:jr nz,xor_lp
 inc h:jr nz,xor_lp
;fill grid
 ld hl,$4000,c,$55
gr_lp:ld (hl),c:inc l:jr nz,gr_lp
 rrc c:inc h
 ld a,h:cp $58:jr nz,gr_lp
;prepare outpic
 ld hl, out_pic
 ld c,24
op1:
 ld (hl),$4D:inc hl; ld c,l
 ld b,32
op2:
 ld (hl),$7E:inc hl; ld a,(hl)
 ld (hl),$12:inc hl; ld (de),a
 ld (hl),$13:inc hl; inc de
 ld (hl),$2C:inc hl; inc l
 djnz op2
 ld (hl),$69:inc hl; ld l,c
 ld (hl),$24:inc hl; inc h
 dec c:jr nz, op1

 ld (hl),$c9:inc hl; ret

 ld ix,dirs+1
tmpb equ $AE00
;clear
 ld hl,tmpb,de,tmpb+1,bc,$500,(hl),l:ldir

snake_lp:
 ei:halt

; ld a,0:out ($FE),a
 
 ld hl,tmpb+$200,de,$5800,bc,$300:ldir

; ld a,7:out ($FE),a

 ld hl,(snakexy+1)
 ld a,h:or $C0:ld h,a
 ld de,tmpb+$200
 call out_pic
 
snakexy:ld de,0
 
 ld a,e:add a,(ix+0)
 jp m,xx
 cp 31:jr nz,end_x
xx:
 call change_dir
 jr skip_y
end_x:
 ld e,a

 ld a,d:add a,(ix+4)
 jp m,yy
 cp 24:jp nz,end_y
yy:
 call change_dir
 jr skip_y
end_y:
 ld d,a
skip_y:
 ld (snakexy+1),de
 
 ld l,d,h,0
 
 ld d,h
; ld a,l
; and 16
; out ($FE),a
; nop
 
 
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 ;ld d,0
 add hl,de
 ld bc,tmpb+$200
 add hl,bc
 ex de,hl

; jr $
snake_t:ld hl,tmpb
 ld (hl),e:inc h
 ld (hl),d:dec h
 inc l:ld (snake_t+1),hl

 ld b,15
snake_d:
 ld e,(hl):inc h
 ld d,(hl):dec h
 
 ld a,$7F,(de),a
 dec l:djnz snake_d
 ld (hl),0:inc h:ld (hl),0
 
snake_l:ld a,15
 dec a
 ld (snake_l+1),a
 jp p,snake_lp
 ld a,r
 cpl
 ld r,a


 and 31
 ld (snake_l+1),a
 call change_dir
 jp snake_lp


change_dir:
 push af
 ld a,ixl
 inc a
 and 3
 ld ixl,a
 

 ld b,a
 inc b
mm:
 cpl
 and 16
 out ($FE),a
 nop
 djnz mm


skippy:
 pop af
 ret

out_pic:

end
	display/d,runi
	display /d,end-begin
	savesna "!snaker.sna",runi
	savebin "snaker.code",begin,end-begin

